function [ sol, val ] = argmax_f( T, PS_node, PS_edge )
%argmax_f argmax of potentials
%   use veterbi algorithm on tree

    [nc, nn] = size(PS_node);

    Z = zeros(nc, nn, 'int64');          % store argmax
    F = zeros(nc, nn);                   % store max

    % find max
    for i = nn:-1:1
        ch_ids = find(T(i+1:end) == i);
        if isempty(ch_ids)              % leaf node
            for k = 1:nc                % each class
                candidate = zeros(nc,1);
                for l = 1:nc
                    candidate(l) = PS_node(l,i) + PS_edge(k,l,i) + PS_node(k,T(i));
                end
                [v, id] = max(candidate);
                F(k,i) = v;
                Z(k,i) = id;
            end
        else                            % has childeren
            for k = 1:nc                % each class
                candidate = zeros(nc,1);
                for l = 1:nc
                    for m = 1:length(ch_ids)
                        j = ch_ids(m);
                        candidate(l) = candidate(l) + F(l, i+j) - PS_node(l,i);
                    end
                    candidate(l) = candidate(l) + PS_node(l,i) + PS_edge(k,l,i);
                    if i ~= 1
                        candidate(l) = candidate(l) + PS_node(k,T(i));
                    end
                end
                [v, id] = max(candidate);
                F(k,i) = v;
                Z(k,i) = id;
            end
        end
    end

    % backtrack
    val = F(1,1);
    sol = zeros(nn, 1, 'int64');
    sol(1) = Z(1,1);
    for i = 2:nn
        sol(i) = Z(sol(T(i)),i);
    end

end

