function [ sol, val ] = argmax_f_vec( T, PS_node, PS_edge )
%argmax_f argmax of potentials
%   use veterbi algorithm on tree

[nc, nn] = size(PS_node);

Z = zeros(nc, nn);          % store argmax
F = zeros(nc, nn);                   % store max

% find max
for i = nn:-1:1
    ch_ids = find(T(i+1:end) == i);
    if isempty(ch_ids)              % leaf node
        for k = 1:nc                % each class
            candidate = PS_node(:,i) + PS_edge(k,:,i)' + PS_node(k,T(i));
            [v, id] = max(candidate);
            F(k,i) = v;
            Z(k,i) = id;
        end
    else                            % has childeren
        for k = 1:nc                % each class
            candidate = PS_node(:,i) + PS_edge(k,:,i)';
            for m = 1:length(ch_ids)
                j = ch_ids(m);
                candidate = candidate + F(:, i+j) - PS_node(:,i);
            end
            if i ~= 1
                candidate = candidate + PS_node(k,T(i));
            end
            [v, id] = max(candidate);
            F(k,i) = v;
            Z(k,i) = id;
        end
    end
end

% backtrack
val = F(1,1);
sol = zeros(nn, 1);
sol(1) = Z(1,1);
for i = 2:nn
    sol(i) = Z(sol(T(i)),i);
end


end

