#include <stdio.h> 
#include <stdlib.h>
#include <time.h>

double rand01()
{
    return (double)rand() / (double)RAND_MAX ;
}

double* random_array_10million(){
    static double X[10000000];

    for(int i = 0; i<10000000; i++) {
        X[i] = rand01();
    }

    return X;
}

double sum2(size_t n, double *X) {
    double s = 0.0;
    for (size_t i = 0; i < n; ++i) {
        s += 2 * X[i];
    }
    return s;
}

int main() {

    int n = 10000000;  // 10 million
    // generate array
    double* X = random_array_10million();

    clock_t start = clock(), diff;

    // compute
    double result = sum2(n, X) / n;

    diff = clock() - start;

    int msec = diff * 1000 / CLOCKS_PER_SEC;
    printf("Result: %f | time : %d miliseconds \n", result, msec);

    return 0;
}

// gcc test_sum.c -o sum_app
// gcc -O3 test_sum.c -o sum_app
// ./sum_app